#include "libnazgul.h"

#define DEBUG 1

int msgSpaceListRem(msgSpaceId spaceId){
  msgSpaceList * list;
  msgSpaceListElemId listHeadElemId;
  msgSpaceListElemId listTailElemId;
  msgSpaceListId listId;

  msgSpaceListElemId prevElemId;
  msgSpaceListElemId currElemId;
  msgSpaceListElemId nextElemId;

  msgSpaceListElem * prevElem;
  msgSpaceListElem * currElem;
  msgSpaceListElem * nextElem;
  msgSpaceId currSpaceId;	

  list=msgSpaceListOpen();
  if (list==NULL){
	NZG_ERROR("msgSpaceListOpen","");
	goto ERROR;
  }
  if (DEBUG) { printf("Before ListStrCpy\n"); }
  strcpy(listHeadElemId,list->headId);
  strcpy(listTailElemId,list->tailId);
  strcpy(listId,list->id);
  if (DEBUG) { printf("After ListStrCpy\n"); }
  if ((strcmp(listHeadElemId,listId)==0) 
	  && strcmp(listTailElemId,listId)==0){
	if (DEBUG) { printf("SpaceList : vide\n"); }
	return 1;
  } else {
	bool found=false;

	strcpy(prevElemId,list->headId);
	strcpy(currElemId,list->headId);
	while(!found){
	  printf("Recherche dans l'element %s\n",listHeadElemId);
	  currElem=msgSpaceListElemOpen(currElemId);
	  if (currElem==NULL){
		NZG_ERROR("msgSpaceListElemOpen",currElemId);
		goto ERROR;
	  }
	  strcpy(nextElemId,currElem->next);
	  strcpy(currSpaceId,currElem->spaceId);
	  if (msgSpaceListElemClose(currElem) <0){
		NZG_ERROR("msgSpaceListElemClose",currElemId);
		goto ERROR;
	  }
	  if (strcmp(prevElemId,nextElemId)==0){
		// list  1 seul lement
		if (strcmp(currElem->spaceId,spaceId)==0){
		  // on a trouv l'elem
		  strcpy(list->headId,list->id);
		  strcpy(list->tailId,list->id);
		  // on efface
		  shm_unlink(currElemId);
		  found=true;
		} else {
		  break;
		}
	  } else {
		// liste  plusieurs lements...
		if (strcmp(currElem->spaceId,spaceId)==0){
		  // ca correspond
		  // si on est en dbut de liste (prev=current)
		  // - la tete de liste pointe sur le suivant
		  // - on dtruit l'actuel
		  // si on est en find de liste (current=next)
		  // - on fait pointer le prcdent sur luimeme
		  // - on fait pointer la queue de liste sur le prcdent
		  // - on dtruit l'actuel
		  // sinon :
		  // - on fait pointer le prcdent sur le suivant
		  // - on dtruit l'actuel
		  found=true;
		  break;
		} else {
		  //cela ne correspond pas
		  //on recopie
		  strcpy(prevElemId,currElemId);
		  strcpy(currElemId,nextElemId);
		}
	  }

	}
	if (msgSpaceListClose(list) < 0){
	  NZG_ERROR("msgSpaceListClose","");
	  goto ERROR;
	}
	return 0;
  }
ERROR:
  return -1;
}

